class DummySingletonClass
  include Singleton
  include MSP

  def pub(param); end

  protected

  def pro(param); end

  private

  def pri(param); end
end

describe MSP::SingletonService do
  describe '#method_missing' do
    it 'calls #pub public method' do
      expect(DummySingletonClass.instance).to receive(:pub).with('arg')
      DummySingletonClass.pub('arg')
    end

    it 'calls #pro protected method' do
      expect(DummySingletonClass.instance).to receive(:pro).with('arg')
      DummySingletonClass.pro('arg')
    end

    it 'calls #pri private method' do
      expect(DummySingletonClass.instance).to receive(:pri).with('arg')
      DummySingletonClass.pri('arg')
    end

    it 'raises NoMethodError' do
      expect { DummySingletonClass.wtf }.to raise_error NoMethodError
    end

    it 'raises ArgumentError' do
      expect { DummySingletonClass.pub }.to raise_error ArgumentError
    end
  end
end
